Attribute VB_Name = "modRotate"
' 
'   (Mikle).
'www.vbstreets.ru

Option Explicit

Private Type Col
  r As Long
  g As Long
  b As Long
End Type

'     
'    
'   ,    0,  Long
'sx, sy -    
'dx, dy -    
'a -    
'BackCol -  

Public Sub RGBRotateAA(ArIn() As Long, ArOut() As Long, ByVal sx As Single, ByVal sy As Single, ByVal dx As Single, ByVal dy As Single, ByVal a As Single, ByVal BackCol As Long)
  Dim sw As Long, sh As Long, dw As Long, dh As Long
  Dim x As Long, y As Long
  Dim xx As Single, yy As Single
  Dim tx As Single, ty As Single
  Dim ix As Long, iy As Long
  Dim SinA As Single, CosA As Single
  Dim c As Col, bc As Col
  bc = RGBToCol(BackCol)
  sw = UBound(ArIn(), 1) + 1
  sh = UBound(ArIn(), 2) + 1
  dw = UBound(ArOut(), 1) + 1
  dh = UBound(ArOut(), 2) + 1
  SinA = Sin(a)
  CosA = Cos(a)
  For y = 0 To dh - 1
    tx = sx - dx * CosA + (y - dy) * SinA
    ty = sy + (y - dy) * CosA + dx * SinA
    For x = 0 To dw - 1
      tx = tx + CosA
      ty = ty - SinA
      ix = Int(tx): iy = Int(ty)
      xx = tx - ix: yy = ty - iy
      If ix < -1 Or ix >= sw Or iy < -1 Or iy >= sh Then
        ArOut(x, y) = BackCol
      ElseIf ix >= 0 And ix < sw - 1 And iy >= 0 And iy < sh - 1 Then
        c = ColMulVal(RGBToCol(ArIn(ix, iy)), (1 - xx) * (1 - yy))
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy)), xx * (1 - yy))
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix, iy + 1)), (1 - xx) * yy)
        ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy + 1)), xx * yy)
        ArOut(x, y) = ColToRGB(c)
      Else
        If ix = -1 Or iy = -1 Then c = ColMulVal(bc, (1 - xx) * (1 - yy)) Else c = ColMulVal(RGBToCol(ArIn(ix, iy)), (1 - xx) * (1 - yy))
        If ix = sw - 1 Or iy = -1 Then ColAddCol c, ColMulVal(bc, xx * (1 - yy)) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy)), xx * (1 - yy))
        If ix = -1 Or iy = sh - 1 Then ColAddCol c, ColMulVal(bc, (1 - xx) * yy) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix, iy + 1)), (1 - xx) * yy)
        If ix = sw - 1 Or iy = sh - 1 Then ColAddCol c, ColMulVal(bc, xx * yy) Else ColAddCol c, ColMulVal(RGBToCol(ArIn(ix + 1, iy + 1)), xx * yy)
        ArOut(x, y) = ColToRGB(c)
      End If
    Next x
  Next y
End Sub

'   

Public Sub RGBRotate(ArIn() As Long, ArOut() As Long, ByVal sx As Single, ByVal sy As Single, ByVal dx As Single, ByVal dy As Single, ByVal a As Single, ByVal BackCol As Long)
  Dim sw As Long, sh As Long, dw As Long, dh As Long
  Dim x As Long, y As Long
  Dim xx As Single, yy As Single
  Dim ix As Long, iy As Long
  Dim SinA As Single, CosA As Single
  sw = UBound(ArIn(), 1) + 1
  sh = UBound(ArIn(), 2) + 1
  dw = UBound(ArOut(), 1) + 1
  dh = UBound(ArOut(), 2) + 1
  SinA = Sin(a)
  CosA = Cos(a)
  For y = 0 To dh - 1
    xx = sx - dx * CosA + (y - dy) * SinA
    yy = sy + (y - dy) * CosA + dx * SinA
    For x = 0 To dw - 1
      xx = xx + CosA
      yy = yy - SinA
      ix = xx: iy = yy
      If ix < 0 Or ix >= sw Or iy < 0 Or iy >= sh Then
        ArOut(x, y) = BackCol
      Else
        ArOut(x, y) = ArIn(ix, iy)
      End If
    Next x
  Next y
End Sub

' 
Private Sub ColAddCol(Dest As Col, Src As Col)
  Dest.r = Dest.r + Src.r
  Dest.g = Dest.g + Src.g
  Dest.b = Dest.b + Src.b
End Sub

Private Function ColMulVal(Src As Col, v As Single) As Col
  ColMulVal.r = Src.r * v
  ColMulVal.g = Src.g * v
  ColMulVal.b = Src.b * v
End Function

Private Function ColToRGB(c As Col) As Long
  ColToRGB = c.r * &H10000 + c.g * &H100 + c.b
End Function

Private Function RGBToCol(ByVal c As Long) As Col
  RGBToCol.r = (c And &HFF0000) \ &H10000
  RGBToCol.g = (c And &HFF00&) \ &H100
  RGBToCol.b = c And &HFF
End Function
